/*
 * Copyright (c) 2015 Vasa Consulting LLC
 *
 * This file is part of TYPE61CHK.
 *
 * TYPE61CHK is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * TYPE61CHK is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with TYPE61CHK.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <sysexits.h>
#include <stdbool.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "CUnit/Basic.h"

#include "tests.h"
#include "support.h"

static char	   *from = "alexander";
static char	   *new_recp = "alexander@example.test";
static char	   *msg = "This is a message\nwith multiple\nlines.";

/* not static because external linkage is required */
char *smtp_username, *smtp_password, *smtp_server;


int
init_suite_curl()
{
	smtp_username = "alexander@example.test";
	smtp_password = "example";
	smtp_server   = "smtp://example.test:587";
	return 0;
}

int
clean_suite_curl()
{
	free_curl();
	return 0;
}

void
testCURLINIT()
{
	int retval = false;
	retval = init_curl(from);
	/* email_from lives in curl.c */
	CU_ASSERT_TRUE(retval);
}

void
testCURLADDRECPTOCURL()
{
	int retval = false;
	retval = add_recp_to_curl(new_recp);
	CU_ASSERT_TRUE(retval);
}

void
testCURLADDMSGTOCURL()
{
	int retval = false;
	retval = add_msg_to_curl(msg, new_recp);
	CU_ASSERT(EX_OK == retval);
}

