/*
 * Copyright (c) 2015 Vasa Consulting LLC
 *
 * This file is part of TYPE61CHK.
 *
 * TYPE61CHK is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * TYPE61CHK is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with TYPE61CHK.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <sysexits.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "CUnit/Basic.h"

#include "tests.h"
#include "support.h"

/* Globals provided by environment, mocked here */


int init_suite_gpgme()
{
	return 0;
}

int clean_suite_gpgme()
{
	return 0;
}

void testGPGMEINITGPGME()
{
	int retval = init_gpgme();

	CU_ASSERT(0 == retval);
}

void
testGPGMEENCRYPTWITHGPGME()
{
	char   *final = NULL;
	size_t	final_len;
	char	sender[] = "alexander@vasaconsulting.com";
	char	msg[] = "Short test message.";
	char   *openpgpkey = NULL;

	openpgpkey = malloc(6773 + 1);

	if (NULL == openpgpkey)
		CU_FAIL("Couldn't malloc space for openpgpkey test value");

	memset(openpgpkey, '\0', 6773 + 1);

	memcpy(openpgpkey, "-----BEGIN PGP PUBLIC KEY BLOCK-----\n", 37);
	memcpy(openpgpkey + 37,
		"mQINBFVVwxUBEADOAp/UZLWpUfKin+llacXGJwr02va0RDgCH1EH/Vs3AbgbBB1S"
		"NKB5b04+Ir2+3hMuaHEXyD9AVmLM+y9XevMl+i2jdwXHvcgg8Gk2llLFLI5iJ8lW"
		"k1eERRWYWXI6br5Z79Ngt2mERsQZFBNVJegGqRYzTJRMSn5vsnLkKIjRDQsNbFUV"
		"almf5TDbs1kFWwjbNHbPwJcA0dCYLrJ5o85jPafjMx9yT48QnSXJlRdmsrRx8/AW"
		"m946SuZA14Va/IDabmpNEuVvLNptSvLiHVQ3cdd5znyatqqBgSXT0MfF7dwIASYe"
		"aFil9+QciJQfTIQhheH1244xRbgb/czYPPgVOYTwYaWdM3/YDGK+HKTvy3ix0DkL"
		"r87KmFJbpx1WyRMzftG7QJvIw49qBYKHaGJm75i6PrIRS2xk1mjJIOeKRdVNOspK"
		"fqHdgKUe2TU/Yg+eXi9XWPM+nuqOzALXKoKnpfRhbSvhk4Wt4Obgoj5eTniSFa1K"
		"2kiTe6ElqNdQYuxTi52PDgp3oH+4zoeiUpGRAVuUWy1se2atHxbhbWbsc/e2bl7I"
		"ERJKBHyDz1VZqC/5QSUo9GAexupGPQN2cGEKOT3sV508q/p0TIq8ceAgtW1MSpBW"
		"eUqwjrvDFonPEDf7esJNKoimUGUrkM3jdaTdNsYxxaHW1Sq6Djdqcwdo+wARAQAB"
		"tBFBbGV4YW5kZXIgVmFzYXJhYokCPQQTAQgAJwUCVVXDFQIbAQUJCWYBgAULCQgH"
		"AwUVCgkICwUWAwIBAAIeAQIXgAAKCRDF/cMsTdd6lH+VD/40o9Hqomvs5TaWnw4/"
		"5gXr49SGQbvE6W8aPYLv3hJkygw0qc/rtDrRSSK9D/Vk4th31rdSHrQfOp9l38Rw"
		"gyt0UCFPP0Vi2tW5IYvtTr02wAPbc9zEsUvTds4CFOW72WDhgbhutH/uWBTvlxoS"
		"9ozD2xCc8UGn9P7i0QVQpxSb1K6Z+QQoMPeo7KhKC6Ydg41a29aIPj4m6NaqmRg/"
		"aEVCnwwIlsLx7VQWNInlTvRzECOd8SFkFnv5n7BYpEg+Km7AoqHvxqprLU5yHG6d"
		"V0Yda8db6V7lO2GOpIEHPv6Nz1g6jtv/vKGsJf+ZB0M4+DJ05Zc9p9JxpaLuyXNK"
		"xUH7Loy/kzP53MThhaHE+0PysqKmdB02P4TY79IngclY9y6Yop8RoHgygKnUHxWR"
		"3rakr7Q0SIMd6dgX2FmgBDZ92pEYYk7/YXtdGPb0dBiLyMcTMwBd/l4Euwlbi+5H"
		"Uh5Sutsl2LNuvFqjI2DYlWRaNonWNs13ufZGQoqF9Qh201PaNggWiAfkcTAhgyQD"
		"bOsIMFiWg9QrYPlYkIVS5pQ48W8+ALWYLUTk/GUDx8siZg89tTxdnpyN7oHt95L0"
		"v2Znu9FbJCQZAKScESGhoWgYutUo8ghzCYFxhKw4v/sG1mE9bdHYKcoQbfYzMXo7"
		"axCvDBK3AxoaGTiFdHitP5GCxLQwQWxleGFuZGVyIFZhc2FyYWIgPGFsZXhhbmRl"
		"ckB2YXNhY29uc3VsdGluZy5jb20+iQI9BBMBCAAnBQJVVcRfAhsBBQkJZgGABQsJ"
		"CAcDBRUKCQgLBRYDAgEAAh4BAheAAAoJEMX9wyxN13qUQw4P/3o/bY+LXWA00TzH"
		"TU7+QAdfCMkw15M7XNbWrCftyKiLLA03Y14xbztAeH8KrJCwEeRHs7U8EuCARI2T"
		"pTd/R12AwqeZfTw0Cr1bJh4p79MeOVV2xj9yJs372yiYGspXrhIPgeiwqdrT9tKX"
		"qxJu2ZolmnNXGnOR6ce4EVg8XqhpDH3jsHHB2LMtxKmdzSbDAX3EyHC2M1NXx8ug"
		"vbkkd2Q5Y8WiVTkdz8YmGyLgQbZzJF7g1r3BIU6XVIZJvT68RSik9guv2KJI45eH"
		"W+egc4gG2nrHbcHLkF2G5E2nh3xmm67+tZNfgT4qiQryLJTZuVsL/to/9C1q9ty4"
		"PnLvMNsDlWDSpG5Vswm7yRvOIyKmbfvDFtMh5UEIWDOB1VE0bf1xqqq6UP9pDpyg"
		"T7XW+27ZARyW4ASC6BpE8Tn2+/46COVV19XJ/VqfsX8UpqlwUFJs1UlMbKzKgGP7"
		"W2k8ff7avvXTfsTiAUKPUKhGatqPHhkot/xSlXR4ABNIdEVq5ESLAYuvLY6uhrYL"
		"8vGT77AvqPQ7lvjnhEDF2TlBZpxdhURCs5wOOlRU7YnFP+PaMQEo/LvIzUmThV+a"
		"HuoqeJ2tFkY4Vnic/9NKiHsqbV6BdrlmFLI0qxexCBVFTg5xK84Uahwe5ZoYEcYc"
		"ogUANl3P27vq5GjEaGINqVHXQF7WuQGNBFVVxIUBDAC6Nx4KRgwRLUHbCo2NdaZ/"
		"yae/WlWdLvHjvEEL2k/VWj9EKnzjHa3ObGfLy5+42fHQjgMwHRybCZ4KAhFWeD75"
		"SGoQRShKMi6+zL06Um9ZZyEAKt3uCVmkjk2cBtqwNu+T66KkYK9wbwiowlSQX6s2"
		"1eIhRjhbFgKL9Tdo7MtYFcE8oGWKw4+vKk2SMI4YIurXQb/8bB8dIsUZoEoKThFS"
		"LiPg80xeNv96lHOpqW0idaGOJImVjMq8CaKnIVyldptV+SotfOi2WX5vdh8J+DLn"
		"/LcQZrr73octH9fO6wZyly4BWnDkCAZDdkT5XbGI0TL3Loaj9l7XUT1VwyhcJdcd"
		"tEsalhbJ6uBqJxhalS2UfO1bRXpFXCSK69sXDbboaBj/sXMVb+iKi86dguHFtBv2"
		"p/eVCkgbDFHF2A6IdOvq3HZ3EOqCHwdjmozcJs1dPJV1OB8VKlR/6P8DjCiW9Qad"
		"HlrGK7OvUwNoaeMi7CbpFE/lzY3IMehKXMVUIO7FSucAEQEAAYkDxAQYAQgADwUC"
		"VVXEhQIbAgUJAO1OAAGpCRDF/cMsTdd6lMDdIAQZAQgABgUCVVXEhQAKCRDQCdE4"
		"agM9pd4wDACty1Q+68FValtViBXrgUKBpjtWg8VfPzdKoYwb18XZhwpSVU0WusZC"
		"mSig6wT4JpKsSHva3TGSLaAYAGrlnXg/axexxUAQCcaunAUs+WngQOmau5Gl/kcU"
		"yXSEdv/Z4/YDyE0J7czouY9nEhGCS/2HV6MPotqbegWL3MUhJ9d2OsCI5nAK0oQT"
		"gzWJ3/iZZTjf9TTbf1wDfXq8VA2+y6cxsI+4704ByLfMhKAxxh3FvX7FR6oSWqWD"
		"D1m0C/IX10FDhY4jPj+idysxdXPDLz1tQFusCDhrKWX9JT8BW66JMkI9YvGDmpCr"
		"NdCy2425JBC/G3wlJU+CA/lYLG5XVyELK2dyw11BpWnrvfDWJV3Se6mX0hDX1DNn",
		3328);

	memcpy(openpgpkey + 37 + 3328,
		"jAxQwMKqRLn+RhKPnHnQ74pMUbRKVERdnfCSxUX3iWC4qHA0zFpfMc1pgTzTAAo3"
		"V4Iuu9xRZ5T6ME4ew5shAfKUoPHUYLlq8yKHLe8BLNmyA6CRGHGNurJU3jOHogqB"
		"ak3QNyx3sokOBg/9G1UR1kpFU/pbmLEakNBBhzEy+TUyfgOfCi1dxo993oe5JaxM"
		"rPjPgFLIugOf9zzV4M1hzDJSRh6iSWGSMbhTdk4fyRUj/MGQ0Uju8NfucWR+dx7O"
		"pu1tcA3LmgzNgRlP3UPjl4jnjmz7USf9R3egbvONwHh4NBGuRYpraYOlH5glMYM9"
		"SEjLrX+eowsR3XOmk1AGVEGTtvlM5/fYyBI+cwPA5shqdJxGGwQ/gcREtB2Is1/I"
		"epXWQYKOAlcXxKnIc1Pcho7oSYRNx8/WFWEUbsNTOtCyI7DH40810IcHpr1YZXV3"
		"VjZDpI7mcwIiJ1dCAbXBbwbFmy+vZPi+KjGNvsfLQCG85lRu4GLM2E/ETQkxuEq3"
		"n6ryYqz3u2zBiG4WeVZeB67XdUgwWRswV43zIgF3G/Qrs11f5h+UfeMt3DNcN324"
		"53hBGyanzlabGrWlCMMj1lgaSccPLN7bwGW/ZNnCgVn15z2giYEum4T7lb42cc92"
		"s05I1ELLau3FQDi3PuCXET5f0LMR0/vzs1xBD3bh+jFncJ+8zlavXxmFCjVKEi5c"
		"ettypSHTrrs6Jr4L8c51uVDKQ8Yg68tomPETR/cyaMg5wBmCNX8Lqnis1Z8UQtjE"
		"nJHQitaY55OGld7NLMRbwfo1bDjrv+Trp2WuBC4mlMqK7+FyyJ04B1GvCey5AY0E"
		"VVXEtAEMAMqSCQmd7LhtmSoD1uhV1PcDQZRtlBP43LUebRPdsLy5olfrSjYsO640"
		"JkrRP897rIjhRFs4fTnW8O2JGfpsdAqxbvuAslmPI9zvd6BLi94dLA/rQrXvKBRl"
		"BcfnRkZh9XvhzAKuTHkVHfHWA7YynIij4zkEK9xfytAWrSA+2Klhki9VrBARp0y7"
		"I2B2jgoav6l76VLrGbNgGP2hyytMLdegz2ZBI0WwjbLeNjlsGqvvRtRkg5+0gwU7"
		"x5MhyrMCO6OpC97rW1korE/eZoSuvXlXUNvqldotiWbPNJH7an014Z1O1W7DdX1K"
		"YFXSSeA+akNsofTEVDD61T76PGB+qKyZRCoBXwe27g47xGZPrVkCK/2n+X67bNe+"
		"iPp/Z7rbBYpPihfm6SfB90cnZYwP52zvgHlinKX2kwNjabnY6iLpAhOAaA2wMDqR"
		"8P5F10tzl5f0KnIYeLDzrajmdJYjoLhS3JRW+R4jdeh5EAKOYl31YtoFmvPGpqDA"
		"apQA5M/mbwARAQABiQIlBBgBCAAPBQJVVcS0AhsMBQkA7U4AAAoJEMX9wyxN13qU"
		"h+EP/jP3l7bjLG7Vir9zeMkXsEMveJT+wIFF4/3eaUNElWd78D95emeuj7wRSdvV"
		"/eu9fPYifoibpWc/YhsO/DA4XyqA3Mm6jPqIUQfzP01qVkW9OMMCzfxROLvCYBqv"
		"AvpmzkDSx4AyfCrqv6xTF9F7YO/nssaEhCQBHMVioG61gQ9HEqUHYovUVvWHL9Bj"
		"K4tlae2Yh4zcIhYUUfufewO+zO1a4cw53LW3Kt0FRYVHhxA4xCpNwN7egSKK/j2e"
		"2/k+xws4ZOBNvwb8WUcM3+J8dSs/fIhlsBaTJrx7+8oLqpbaKNixHtmA0qXcEZR9"
		"ryk916XTuJXzOwTSir7WR2FqrRObv3m1jn8RBMqPcvqppPTUF3qaPO/jiNFHilGC"
		"IeXBqGcpTHPqVZFX6l+fbQCX+hClG8gODg7bLRxmFf3XEYDVsteyo+jhPNb3Lj5L"
		"Sve8cNuxbmvBvXMvMWrgmEw8dk/OeoMGV/ivh1YvPBb1zNPs+yeor9rDlmkR+des"
		"WsEaggA3RmdgGieTpU1j5iBr8rNaQqsTGMEv92wg9SCip7hCTlAUe3t3ujP9g0RG"
		"zT8QYeB3HM8i86af/grke31Zo62q/GNEbPS7GjRpEOrmxG3sxbyLjReLv9s8+2e8"
		"7CrxAo+CQtPfBKbIz84ORoSFkpNwJhoj4V2oxC97PikN2bN/uQGNBFVVxNQBDAC4"
		"xHCIHFn6fucJa5oW4OJ8tdzowrKQTSzzp9WJxivBaxoxHHd4lardbmc2IWCvCIx4"
		"D9IB2VCJmWrfN81WNoB/fWsW1edlRrYQWnSM7+AhF5pQOz7QldPOU17GroSET8q6"
		"9SQ+9PosUX1WDEHKP4gpr/VKD/sgZ5kjWx0tguHFk9KuVn8PKUQPqSaHWBaEn2v3"
		"IfS+iogzTTxx5Is37piJ4kbHGUMBAc3xJih32SaHInxA6VFP0jAoCzaPG+VvTzwN"
		"LOR88BYhVWGdh0NXVgN5Ib/H1JVOZx+QpsHGj/UwmE6inTOvwxgOFF/oRgAtYUOl"
		"V6y1RZIT3pRnws77xrCm6rz9A+UFYj+lXGGYff4dgvUyvKvQ+BVdVuiwxpXBCWWh"
		"/K57971yMiPHIsWNmUTFbTjWCs12Mwfg94CmfmbAPb2HbAccQM/d+VTdKndXxvhX"
		"jwWLq+sNu4OShYKoLB5GVJCYl5b77OYYCzhHxc9YK+IQLE52S8oM+dK5Sa70iIsA"
		"EQEAAYkCJQQYAQgADwUCVVXE1AIbIAUJAO1OAAAKCRDF/cMsTdd6lJCMEACxYsnF"
		"ACPKrjqu20MROkfG2takWG1bDFZw+mohJYLtmVTkjJtgDuW45b+bPfSEc+ACqA2R"
		"O2Hahxp7F7rnYWg6bu9eOpAJnXMT7CItR3hBXSPpOQ1suQPwd9Kubk1GD2JL19H6"
		"Rbx6l9YzV+8wFuBeCCa2Pw9j0QI3IUCreI4LtRsXfDdxxhHX6xueDTjDeO/e/xhI"
		"dWqcXKbP4x3sndCat4PkcBLsIO3QeaCuYBvJbcLRiGRSpzKrWGTtLUV/g63DpLuZ"
		"IEz9zyegajOGL0VbKbg+WkPHbK/qV/8MJYjQhPV5Itkr2GpDIQPYBkGWgIqtGgH1"
		"g+1zZ4c8uD/SoqL7X6WK4ln2rPFOlgNvZzs9izP5H4hlkvKt63SRdahO2IuIsfRm"
		"Wpt7A2EONV7YCuBCubq0kFmOaMu3fSviZP8eNDQLMlfJIN+TjD0znVK3ndUu5D+G"
		"OwB+hj+2iUfFlxBx17Py6DI/rHaqnA0bEwc6cfFvuCGSb+LemzAIaEguXkJhxfrp"
		"TpBCe4l1WjbUc4BvQ/iaC0f1zlQfqYlxrd7ACz1ioyv341xFsJTUh8S39SIJzZAs"
		"G02pXqtlTPneTpg8pYT1aB7ISh+HhhEbhlNg8YCHCrrrycaho2SFfS3ytNosUzhe"
		"9FShx257B8Q5go0YEuZ+z7kCVDY7dul75SeDwQ==" /* 3368 bytes so far */
		"=HfHE\n"								   /* + 6 */
		"-----END PGP PUBLIC KEY BLOCK-----",	   /* + 34 */
		3408);

	openpgpkey[6773+1] = '\0';

	final = encrypt_with_gpgme(sender, msg, openpgpkey);

	CU_ASSERT_PTR_NOT_NULL_FATAL(final);

	final_len = strlen(final);

	CU_ASSERT_NSTRING_EQUAL(final, "-----BEGIN PGP MESSAGE-----", 27);
	CU_ASSERT_NSTRING_EQUAL(final + final_len - 26,
							"-----END PGP MESSAGE-----\n",
							26);

	/*
	 * These seem like reasonable length bounds given the default GPG
	 * input parameters at the time of this writing.
	 */
	CU_ASSERT(final_len > 0x7f);
	CU_ASSERT(final_len < 0x400);
}

void
testGPGMEFREEGPGME()
{
	free_gpgme();
	CU_PASS();
}

