/*
 * Copyright (c) 2015 Vasa Consulting LLC
 *
 * This file is part of TYPE61CHK.
 *
 * TYPE61CHK is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * TYPE61CHK is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with TYPE61CHK.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <sysexits.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "CUnit/Basic.h"

#include "tests.h"
#include "support.h"

/* Globals provided by environment, mocked here */


int init_suite_ldns()
{
	return 0;
}

int clean_suite_ldns()
{
	return 0;
}

void testLDNSFETCHOPENPGPKEY()
{
	int		retval;
	char   *user_hashed = "2d41ad159bbc21a20a4e05ceb1b0"
						  "037aaf7821bc47ec8443af5fa3a7";
	char   *domain = "vasaconsulting.com";
	char   *openpgpkey = NULL;

	retval = fetch_openpgpkey(user_hashed, domain, &openpgpkey);

	CU_ASSERT(0 == retval);
	CU_ASSERT_PTR_NOT_NULL_FATAL(openpgpkey);
	CU_ASSERT(strlen(openpgpkey) > 1000);
	CU_ASSERT(strlen(openpgpkey) < 10000);

	free(openpgpkey);
}

void testLDNSQUERYTEXTLDNS()
{
	char   *query = NULL;
	char   *target = "2d41ad159bbc21a20a4e05ceb1b0"
					 "037aaf7821bc47ec8443af5fa3a7"
					 "._openpgpkey.vasaconsulting.com";

	query = query_text_ldns();

	CU_ASSERT_STRING_EQUAL(query, target);
	free(query);
}

void testLDNSFREELDNS()
{
	free_ldns();
	CU_PASS();
}

