/*
 * Copyright (c) 2015 Vasa Consulting LLC
 *
 * This file is part of TYPE61CHK.
 *
 * TYPE61CHK is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * TYPE61CHK is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with TYPE61CHK.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <sysexits.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "CUnit/Basic.h"

#include "tests.h"
#include "support.h"

/* Globals provided by environment, mocked here */
static char *user = "alexander";
static char *hashed = NULL;
static char *res = "2d41ad159bbc21a20a4e05ceb1b0037aaf7821bc47ec8443af5fa3a7";


int init_suite_sha()
{
	hashed = malloc(sizeof(char) * T61_SHA224_BYTES + 1);
	memset(hashed, '\0', sizeof(char) * T61_SHA224_BYTES + 1);
	return 0;
}

int clean_suite_sha()
{
	if (hashed != NULL)
		free(hashed);

	return 0;
}

void testSHAINIT()
{
	int retval = init_sha();

	/* OpenSSL uses 1 for success, 0 for failure */
	CU_ASSERT(1 == retval);
}

void testSHAHASHUSER()
{
	int retval = 0;
	retval = hash_user(user, hashed);

	CU_ASSERT(EX_OK == retval);
	CU_ASSERT_EQUAL(56, strlen(hashed));
	CU_ASSERT_NSTRING_EQUAL(hashed, res, 56);
}

